/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.add_general;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderAdd_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAdd_general extends DecoderItem {
  private static DecoderAdd_general instance = null;

  public static DecoderAdd_general get() {
    if (null == instance) {
      instance = new DecoderAdd_general();
    }
    return instance;
  }

  private DecoderAdd_general() {
    super(
        32,
        true,
        "01111100000000000000001000010100",
        "11111100000000000000001111111110"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate Rc_op = null;
    Immediate OE_op = null;
    R rd = null;
    R ra = null;
    R rb = null;

    if (!matchNextOpc(image, BitVector.valueOf("011111", 2, 6))) {
      return null;
    }
    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    rb = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rb) {
      return null;
    }
    OE_op = readNextImmediate(image, BIT);
    if (!matchNextOpc(image, BitVector.valueOf("100001010", 2, 9))) {
      return null;
    }
    Rc_op = readNextImmediate(image, BIT);

    return newResult(new add_general(Rc_op, OE_op, rd, ra, rb));
  }
}
