/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.addeo_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.adde_general;

/**
 * The {@code DecoderAddeo_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAddeo_d extends DecoderItem {
  private static DecoderAddeo_d instance = null;

  public static DecoderAddeo_d get() {
    if (null == instance) {
      instance = new DecoderAddeo_d();
    }
    return instance;
  }

  private DecoderAddeo_d() {
    super(
        32,
        true,
        "01111100000000000000010100010101",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;
    R rb = null;

    final adde_general adde_general_instance;
    adde_general_instance = (adde_general) readNextPrimitive(image, DecoderAdde_general.get());
    if (null == adde_general_instance) {
      return null;
    }
    rd = adde_general_instance.rd;
    ra = adde_general_instance.ra;
    rb = adde_general_instance.rb;

    return newResult(new addeo_d(rd, ra, rb));
  }
}
