/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.cmpl;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderCmpl} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCmpl extends DecoderItem {
  private static DecoderCmpl instance = null;

  public static DecoderCmpl get() {
    if (null == instance) {
      instance = new DecoderCmpl();
    }
    return instance;
  }

  private DecoderCmpl() {
    super(
        32,
        true,
        "01111100000000000000000001000000",
        "11111100001000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate crfD = null;
    Immediate L = null;
    R ra = null;
    R rb = null;

    if (!matchNextOpc(image, BitVector.valueOf("011111", 2, 6))) {
      return null;
    }
    crfD = readNextImmediate(image, CRFD);
    L = readNextImmediate(image, BIT);
    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    rb = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rb) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0000100000", 2, 10))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }

    return newResult(new cmpl(crfD, L, ra, rb));
  }
}
