/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.cmpli;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderCmpli} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCmpli extends DecoderItem {
  private static DecoderCmpli instance = null;

  public static DecoderCmpli get() {
    if (null == instance) {
      instance = new DecoderCmpli();
    }
    return instance;
  }

  private DecoderCmpli() {
    super(
        32,
        true,
        "00101000000000000000000000000000",
        "11111100001000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate crfD = null;
    Immediate L = null;
    R ra = null;
    Immediate UIMM = null;

    if (!matchNextOpc(image, BitVector.valueOf("001010", 2, 6))) {
      return null;
    }
    crfD = readNextImmediate(image, CRFD);
    L = readNextImmediate(image, BIT);
    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    UIMM = readNextImmediate(image, HWORD);

    return newResult(new cmpli(crfD, L, ra, UIMM));
  }
}
