/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.extsh;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.extsh_general;

/**
 * The {@code DecoderExtsh} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderExtsh extends DecoderItem {
  private static DecoderExtsh instance = null;

  public static DecoderExtsh get() {
    if (null == instance) {
      instance = new DecoderExtsh();
    }
    return instance;
  }

  private DecoderExtsh() {
    super(
        32,
        true,
        "01111100000000000000011100110100",
        "11111100000000001111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;

    final extsh_general extsh_general_instance;
    extsh_general_instance = (extsh_general) readNextPrimitive(image, DecoderExtsh_general.get());
    if (null == extsh_general_instance) {
      return null;
    }
    ra = extsh_general_instance.ra;
    rs = extsh_general_instance.rs;

    return newResult(new extsh(ra, rs));
  }
}
