/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.mulhwu_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.mulhwu_general;

/**
 * The {@code DecoderMulhwu_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMulhwu_d extends DecoderItem {
  private static DecoderMulhwu_d instance = null;

  public static DecoderMulhwu_d get() {
    if (null == instance) {
      instance = new DecoderMulhwu_d();
    }
    return instance;
  }

  private DecoderMulhwu_d() {
    super(
        32,
        true,
        "01111100000000000000000010000111",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;
    R rb = null;

    final mulhwu_general mulhwu_general_instance;
    mulhwu_general_instance = (mulhwu_general) readNextPrimitive(image, DecoderMulhwu_general.get());
    if (null == mulhwu_general_instance) {
      return null;
    }
    rd = mulhwu_general_instance.rd;
    ra = mulhwu_general_instance.ra;
    rb = mulhwu_general_instance.rb;

    return newResult(new mulhwu_d(rd, ra, rb));
  }
}
