/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.neg;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.neg_general;

/**
 * The {@code DecoderNeg} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderNeg extends DecoderItem {
  private static DecoderNeg instance = null;

  public static DecoderNeg get() {
    if (null == instance) {
      instance = new DecoderNeg();
    }
    return instance;
  }

  private DecoderNeg() {
    super(
        32,
        true,
        "01111100000000000000000011010000",
        "11111100000000001111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;

    final neg_general neg_general_instance;
    neg_general_instance = (neg_general) readNextPrimitive(image, DecoderNeg_general.get());
    if (null == neg_general_instance) {
      return null;
    }
    rd = neg_general_instance.rd;
    ra = neg_general_instance.ra;

    return newResult(new neg(rd, ra));
  }
}
