/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.ori;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderOri} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderOri extends DecoderItem {
  private static DecoderOri instance = null;

  public static DecoderOri get() {
    if (null == instance) {
      instance = new DecoderOri();
    }
    return instance;
  }

  private DecoderOri() {
    super(
        32,
        true,
        "01100000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    Immediate uimm = null;

    if (!matchNextOpc(image, BitVector.valueOf("011000", 2, 6))) {
      return null;
    }
    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    uimm = readNextImmediate(image, HWORD);

    return newResult(new ori(ra, rs, uimm));
  }
}
