/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.rlwimi_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.rlwimi_general;

/**
 * The {@code DecoderRlwimi_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderRlwimi_d extends DecoderItem {
  private static DecoderRlwimi_d instance = null;

  public static DecoderRlwimi_d get() {
    if (null == instance) {
      instance = new DecoderRlwimi_d();
    }
    return instance;
  }

  private DecoderRlwimi_d() {
    super(
        32,
        true,
        "01010000000000000000000000000001",
        "11111100000000000000000000000001"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    Immediate SH = null;
    Immediate MB = null;
    Immediate ME = null;

    final rlwimi_general rlwimi_general_instance;
    rlwimi_general_instance = (rlwimi_general) readNextPrimitive(image, DecoderRlwimi_general.get());
    if (null == rlwimi_general_instance) {
      return null;
    }
    ra = rlwimi_general_instance.ra;
    rs = rlwimi_general_instance.rs;
    SH = rlwimi_general_instance.SH;
    MB = rlwimi_general_instance.MB;
    ME = rlwimi_general_instance.ME;

    return newResult(new rlwimi_d(ra, rs, SH, MB, ME));
  }
}
