/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.rlwimi_general;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderRlwimi_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderRlwimi_general extends DecoderItem {
  private static DecoderRlwimi_general instance = null;

  public static DecoderRlwimi_general get() {
    if (null == instance) {
      instance = new DecoderRlwimi_general();
    }
    return instance;
  }

  private DecoderRlwimi_general() {
    super(
        32,
        true,
        "01010000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate Rc_op = null;
    R ra = null;
    R rs = null;
    Immediate SH = null;
    Immediate MB = null;
    Immediate ME = null;

    if (!matchNextOpc(image, BitVector.valueOf("010100", 2, 6))) {
      return null;
    }
    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    SH = readNextImmediate(image, SHIFT);
    MB = readNextImmediate(image, SHIFT);
    ME = readNextImmediate(image, SHIFT);
    Rc_op = readNextImmediate(image, BIT);

    return newResult(new rlwimi_general(Rc_op, ra, rs, SH, MB, ME));
  }
}
