/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.rlwnm;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.rlwnm_general;

/**
 * The {@code DecoderRlwnm} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderRlwnm extends DecoderItem {
  private static DecoderRlwnm instance = null;

  public static DecoderRlwnm get() {
    if (null == instance) {
      instance = new DecoderRlwnm();
    }
    return instance;
  }

  private DecoderRlwnm() {
    super(
        32,
        true,
        "01011100000000000000000000000000",
        "11111100000000000000000000000001"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    R rb = null;
    Immediate MB = null;
    Immediate ME = null;

    final rlwnm_general rlwnm_general_instance;
    rlwnm_general_instance = (rlwnm_general) readNextPrimitive(image, DecoderRlwnm_general.get());
    if (null == rlwnm_general_instance) {
      return null;
    }
    ra = rlwnm_general_instance.ra;
    rs = rlwnm_general_instance.rs;
    rb = rlwnm_general_instance.rb;
    MB = rlwnm_general_instance.MB;
    ME = rlwnm_general_instance.ME;

    return newResult(new rlwnm(ra, rs, rb, MB, ME));
  }
}
