/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.slx_general_image;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSlx_general_image} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSlx_general_image extends DecoderItem {
  private static DecoderSlx_general_image instance = null;

  public static DecoderSlx_general_image get() {
    if (null == instance) {
      instance = new DecoderSlx_general_image();
    }
    return instance;
  }

  private DecoderSlx_general_image() {
    super(
        32,
        true,
        "01111100000000000000000000000000",
        "11111100000000000000000000000001"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rsd = null;
    R ra = null;
    R rb = null;
    Immediate opcd_op = null;

    if (!matchNextOpc(image, BitVector.valueOf("011111", 2, 6))) {
      return null;
    }
    rsd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rsd) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    rb = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rb) {
      return null;
    }
    opcd_op = readNextImmediate(image, Type.CARD(10));
    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }

    return newResult(new slx_general_image(rsd, ra, rb, opcd_op));
  }
}
