/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.srawi_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.srawi_general;

/**
 * The {@code DecoderSrawi_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSrawi_d extends DecoderItem {
  private static DecoderSrawi_d instance = null;

  public static DecoderSrawi_d get() {
    if (null == instance) {
      instance = new DecoderSrawi_d();
    }
    return instance;
  }

  private DecoderSrawi_d() {
    super(
        32,
        true,
        "01111100000000000000011001110001",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    Immediate SH = null;

    final srawi_general srawi_general_instance;
    srawi_general_instance = (srawi_general) readNextPrimitive(image, DecoderSrawi_general.get());
    if (null == srawi_general_instance) {
      return null;
    }
    ra = srawi_general_instance.ra;
    rs = srawi_general_instance.rs;
    SH = srawi_general_instance.SH;

    return newResult(new srawi_d(ra, rs, SH));
  }
}
