/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.sthux;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.slx_general_image;

/**
 * The {@code DecoderSthux} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSthux extends DecoderItem {
  private static DecoderSthux instance = null;

  public static DecoderSthux get() {
    if (null == instance) {
      instance = new DecoderSthux();
    }
    return instance;
  }

  private DecoderSthux() {
    super(
        32,
        true,
        "01111100000000000000001101101110",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rs = null;
    R ra = null;
    R rb = null;

    final slx_general_image slx_general_image_instance;
    slx_general_image_instance = (slx_general_image) readNextPrimitive(image, DecoderSlx_general_image.get());
    if (null == slx_general_image_instance) {
      return null;
    }
    rs = slx_general_image_instance.rsd;
    ra = slx_general_image_instance.ra;
    rb = slx_general_image_instance.rb;

    return newResult(new sthux(rs, ra, rb));
  }
}
