/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code MMU} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU extends Mmu<PA> {
  private static MMU instance = null;

  public static MMU get() {
    if (null == instance) {
      instance = new MMU();
    }
    return instance;
  }

  private MMU() {}

  @Override
  public int getAddressBitSize() {
    return 36;
  }

  @Override
  public int getDataBitSize() {
    return 64;
  }

  @Override
  protected PA newAddress() {
    return new PA();
  }

  @Override
  public BitVector getData(final PA pa) {
    final BitVector data = BitVector.newEmpty(64);

    data.assign(MEM.get().getData(pa).asBitVector());

    return data;
  }

  @Override
  public BitVector setData(final PA pa, final BitVector data) {
    MEM.get().setData(pa).assign(data);

    return null;
  }
}
