/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.mmu.spec;

import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.microtesk.mmu.basis.MemoryOperation;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code MMU} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU {
  public final PA pa = PA.get();

  public final NodeVariable data;

  public final MmuAction START;
  public final MmuAction STOP;

  private final MmuAction IF_READ;
  private final MmuAction ASSIGN_0;

  private final MmuAction IF_WRITE;
  private final MmuAction ASSIGN_1;

  protected MMU(final MmuSubsystem.Builder builder) {
    this(builder, "MMU");
  }

  private MMU(final MmuSubsystem.Builder builder, final String name) {
    builder.setName("MMU");

    this.data = new NodeVariable(name + ".data", DataType.bitVector(64));
    builder.setDataVariable(data);


    this.START = new MmuAction(name + ".START");
    builder.registerAction(START);
    this.STOP = new MmuAction(name + ".STOP");
    builder.registerAction(STOP);

    this.IF_READ = new MmuAction(name + ".IF_READ");
    builder.registerAction(IF_READ);
    builder.registerTransition(new MmuTransition(START, IF_READ, new MmuGuard(MemoryOperation.LOAD)));
    this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), new MmuBinding(data, MEM.get().DATA));
    builder.registerAction(ASSIGN_0);
    builder.registerTransition(new MmuTransition(IF_READ, ASSIGN_0));
    builder.registerTransition(new MmuTransition(ASSIGN_0, STOP));

    this.IF_WRITE = new MmuAction(name + ".IF_WRITE");
    builder.registerAction(IF_WRITE);
    builder.registerTransition(new MmuTransition(START, IF_WRITE, new MmuGuard(MemoryOperation.STORE)));
    this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBufferAccess(MEM.get(), BufferAccessEvent.WRITE, MEM.get().getAddress(), MEM.get(), null), new MmuBinding(MEM.get().DATA, data));
    builder.registerAction(ASSIGN_1);
    builder.registerTransition(new MmuTransition(IF_WRITE, ASSIGN_1));
    builder.registerTransition(new MmuTransition(ASSIGN_1, STOP));
  }
}
