/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class addze_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "addze_general",
          addze_general.class,
          null
          );
      addArgument("Rc_op", BIT);
      addArgument("OE_op", BIT);
      addArgument("rd", R.INFO);
      addArgument("ra", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate Rc_op = (Immediate) getArgument("Rc_op", args);
      final Immediate OE_op = (Immediate) getArgument("OE_op", args);
      final R rd = (R) getArgument("rd", args);
      final R ra = (R) getArgument("ra", args);

      return new addze_general(Rc_op, OE_op, rd, ra);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate Rc_op;
  public final Immediate OE_op;
  public final R rd;
  public final R ra;

  public addze_general(final Immediate Rc_op, final Immediate OE_op, final R rd, final R ra) {
    this.Rc_op = Rc_op;
    this.OE_op = OE_op;
    this.rd = rd;
    this.ra = ra;

    addArgument("Rc_op", Rc_op);
    addArgument("OE_op", OE_op);
    addArgument("rd", rd);
    addArgument("ra", ra);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.XO_9.access().store(Data.valueOf(Type.CARD(9), 0xca));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x1f));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s, %s", rd.text(vars__), ra.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s%5s%1s%9s%1s", vars__.OPCD.access().load().toString(), rd.image(vars__), ra.image(vars__), "00000", OE_op.access().load().toString(), vars__.XO_9.access().load().toString(), Rc_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.temp33.access().store(Data.zeroExtend(Type.CARD(33), ra.access(pe__, vars__).load()).add(Data.zeroExtend(Type.CARD(33), pe__.XER_CA.access().load())));
    rd.access(pe__, vars__).store(vars__.temp33.access().bitField(31, 0).load());
    pe__.XER_CA.access().store(vars__.temp33.access().bitField(32, 32).load());
    if (OE_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.XER_OV.access().store(vars__.temp33.access().bitField(32, 32).load().xor(vars__.temp33.access().bitField(31, 31).load()));
      pe__.XER_SO.access().store(pe__.XER_SO.access().load().or(pe__.XER_OV.access().load()));
    }
    if (Rc_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (rd.access(pe__, vars__).load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.CR0_EQ.access().store(Data.valueOf(BIT, 0x1));
      } else if (rd.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(BIT, 0x1))) {
        pe__.CR0_LT.access().store(Data.valueOf(BIT, 0x1));
      } else {
        pe__.CR0_GT.access().store(Data.valueOf(BIT, 0x1));
      }
      pe__.CR0_SO.access().store(pe__.XER_SO.access().load());
    }
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}