/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class bc extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bc",
          bc.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI_op", SHIFT);
      addArgument("BD", Type.INT(14));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI_op = (Immediate) getArgument("BI_op", args);
      final Immediate BD = (Immediate) getArgument("BD", args);

      return new bc(BO_op, BI_op, BD);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "bc",
          instruction.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI_op", SHIFT);
      addArgument("BD", Type.INT(14));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI_op = (Immediate) getArgument("BI_op", args);
      final Immediate BD = (Immediate) getArgument("BD", args);

      return new instruction(
        new bc(
          BO_op,
          BI_op,
          BD
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate BO_op;
  public final Immediate BI_op;
  public final Immediate BD;

  public bc(final Immediate BO_op, final Immediate BI_op, final Immediate BD) {
    this.BO_op = BO_op;
    this.BI_op = BI_op;
    this.BD = BD;

    addArgument("BO_op", BO_op);
    addArgument("BI_op", BI_op);
    addArgument("BD", BD);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.LK.access().store(Data.valueOf(BIT, 0x0));
    vars__.AA.access().store(Data.valueOf(BIT, 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("bc %s", new bc_general(BO_op, BI_op, BD, new Immediate(vars__.AA.access()), new Immediate(vars__.LK.access())).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new bc_general(BO_op, BI_op, BD, new Immediate(vars__.AA.access()), new Immediate(vars__.LK.access())).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new bc_general(BO_op, BI_op, BD, new Immediate(vars__.AA.access()), new Immediate(vars__.LK.access())).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}