/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class instruction extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "instruction",
          instruction.class,
          null
          );
      addArgument("operation", Op.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive operation = (IsaPrimitive) getArgument("operation", args);

      return new instruction(operation);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive operation;

  public instruction(final IsaPrimitive operation) {
    this.operation = operation;

    addArgument("operation", operation);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return operation.text(vars__);
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return operation.image(vars__);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x0));
    pe__.NEXTPC.access().store(Data.valueOf(DWORD, 0x0));
    operation.execute(pe__, vars__);
    if (pe__.BRANCH.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.CIA.access().store(pe__.NEXTPC.access().load());
    } else {
      pe__.CIA.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}