/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class powerpc_store extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "powerpc_store",
          powerpc_store.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("D", WORD);
      addArgument("ra", R.INFO);
      addArgument("upd", BIT);
      addArgument("byte_num", Type.CARD(3));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final Immediate D = (Immediate) getArgument("D", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate upd = (Immediate) getArgument("upd", args);
      final Immediate byte_num = (Immediate) getArgument("byte_num", args);

      return new powerpc_store(rs, D, ra, upd, byte_num);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;
  public final Immediate D;
  public final R ra;
  public final Immediate upd;
  public final Immediate byte_num;

  public powerpc_store(final R rs, final Immediate D, final R ra, final Immediate upd, final Immediate byte_num) {
    this.rs = rs;
    this.D = D;
    this.ra = ra;
    this.upd = upd;
    this.byte_num = byte_num;

    addArgument("rs", rs);
    addArgument("D", D);
    addArgument("ra", ra);
    addArgument("upd", upd);
    addArgument("byte_num", byte_num);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (ra.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      vars__.temp.access().store(Data.valueOf(WORD, 0x0));
    } else {
      vars__.temp.access().store(ra.access(pe__, vars__).load());
    }
    vars__.temp1.access().store(vars__.temp.access().load().add(D.access().load()));
    vars__.temp_address.access().store(Data.coerce(POWERPC_ADDRESS, vars__.temp1.access().load().shiftRight(Data.valueOf(WORD, 0x3))));
    vars__.temp_lo_index.access().bitField(2, 0).store(vars__.temp1.access().bitField(2, 0).load());
    vars__.temp64.access().store(pe__.MEM.access(vars__.temp_address.access().load()).load());
    if (byte_num.access().load().equals(Data.valueOf(Type.CARD(3), 0x1))) {
      vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0x7).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x0).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(7, 0).load());
      pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
    } else if (byte_num.access().load().equals(Data.valueOf(Type.CARD(3), 0x2))) {
      if (vars__.temp_lo_index.access().load().equals(Data.valueOf(Type.CARD(3), 0x7))) {
        vars__.temp64.access().bitField(63, 56).store(rs.access(pe__, vars__).bitField(7, 0).load());
        pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
        vars__.temp64_0.access().store(pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).load());
        vars__.temp64_0.access().bitField(7, 0).store(rs.access(pe__, vars__).bitField(15, 8).load());
        pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).store(vars__.temp64_0.access().load());
      } else {
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0x7).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x0).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(7, 0).load());
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0xf).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x8).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(15, 8).load());
        pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
      }
    } else if (byte_num.access().load().equals(Data.valueOf(Type.CARD(3), 0x4))) {
      if ((vars__.temp_lo_index.access().load().compareTo(Data.valueOf(Type.CARD(3), 0x4)) > 0)) {
        if (vars__.temp_lo_index.access().load().equals(Data.valueOf(Type.CARD(3), 0x5))) {
          vars__.temp64.access().bitField(47, 40).store(rs.access(pe__, vars__).bitField(7, 0).load());
          vars__.temp64.access().bitField(55, 48).store(rs.access(pe__, vars__).bitField(15, 8).load());
          vars__.temp64.access().bitField(63, 56).store(rs.access(pe__, vars__).bitField(23, 16).load());
          pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
          vars__.temp64_0.access().store(pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).load());
          vars__.temp64_0.access().bitField(7, 0).store(rs.access(pe__, vars__).bitField(31, 24).load());
          pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).store(vars__.temp64_0.access().load());
        } else if (vars__.temp_lo_index.access().load().equals(Data.valueOf(Type.CARD(3), 0x6))) {
          vars__.temp64.access().bitField(55, 48).store(rs.access(pe__, vars__).bitField(7, 0).load());
          vars__.temp64.access().bitField(63, 56).store(rs.access(pe__, vars__).bitField(15, 8).load());
          pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
          vars__.temp64_0.access().store(pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).load());
          vars__.temp64_0.access().bitField(7, 0).store(rs.access(pe__, vars__).bitField(23, 16).load());
          vars__.temp64_0.access().bitField(15, 8).store(rs.access(pe__, vars__).bitField(31, 24).load());
          pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).store(vars__.temp64_0.access().load());
        } else if (vars__.temp_lo_index.access().load().equals(Data.valueOf(Type.CARD(3), 0x7))) {
          vars__.temp64.access().bitField(63, 56).store(rs.access(pe__, vars__).bitField(7, 0).load());
          pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
          vars__.temp64_0.access().store(pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).load());
          vars__.temp64_0.access().bitField(7, 0).store(rs.access(pe__, vars__).bitField(15, 8).load());
          vars__.temp64_0.access().bitField(15, 8).store(rs.access(pe__, vars__).bitField(23, 16).load());
          vars__.temp64_0.access().bitField(23, 16).store(rs.access(pe__, vars__).bitField(31, 24).load());
          pe__.MEM.access(vars__.temp_address.access().load().add(Data.valueOf(POWERPC_ADDRESS, 0x1))).store(vars__.temp64_0.access().load());
        }
      } else {
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0x7).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x0).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(7, 0).load());
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0xf).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x8).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(15, 8).load());
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0x17).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x10).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(23, 16).load());
        vars__.temp64.access().bitField(Data.valueOf(Type.CARD(6), 0x1f).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load()))), Data.valueOf(Type.CARD(6), 0x18).add(Data.valueOf(Type.CARD(6), 0x8).multiply(Data.zeroExtend(Type.CARD(6), vars__.temp_lo_index.access().load())))).store(rs.access(pe__, vars__).bitField(31, 24).load());
        pe__.MEM.access(vars__.temp_address.access().load()).store(vars__.temp64.access().load());
      }
    } else {
      Execution.trace("powerpc_load: wrong type of 'byte_num'");
    }
    if (upd.access().load().equals(Data.valueOf(BIT, 0x1)) && !ra.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      ra.access(pe__, vars__).store(vars__.temp1.access().load());
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}