/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class srawi_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "srawi_general",
          srawi_general.class,
          null
          );
      addArgument("Rc_op", BIT);
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate Rc_op = (Immediate) getArgument("Rc_op", args);
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);

      return new srawi_general(Rc_op, ra, rs, SH);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate Rc_op;
  public final R ra;
  public final R rs;
  public final Immediate SH;

  public srawi_general(final Immediate Rc_op, final R ra, final R rs, final Immediate SH) {
    this.Rc_op = Rc_op;
    this.ra = ra;
    this.rs = rs;
    this.SH = SH;

    addArgument("Rc_op", Rc_op);
    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("SH", SH);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.XO_10.access().store(Data.valueOf(Type.CARD(10), 0x338));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x1f));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s, %s, %d", ra.text(vars__), rs.text(vars__), SH.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s%5s%10s%1s", vars__.OPCD.access().load().toString(), rs.image(vars__), ra.image(vars__), SH.access().load().toString(), vars__.XO_10.access().load().toString(), Rc_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.temp.access().store(Data.valueOf(WORD, 0xffffffffL).shiftLeft(Data.zeroExtend(WORD, SH.access().load())).shiftRight(Data.zeroExtend(WORD, SH.access().load())));
    vars__.temp1.access().store(rs.access(pe__, vars__).load().shiftRight(Data.valueOf(WORD, 0x1f)));
    vars__.temp2.access().store(rs.access(pe__, vars__).load().shiftLeft(Data.valueOf(SHIFT, 0x0).subtract(SH.access().load())).or(rs.access(pe__, vars__).load().shiftRight(SH.access().load())));
    ra.access(pe__, vars__).store(vars__.temp2.access().load().and(vars__.temp.access().load()).or(vars__.temp1.access().load().negate().and(vars__.temp.access().load().not())));
    if (!vars__.temp2.access().load().and(vars__.temp.access().load().not()).equals(Data.valueOf(WORD, 0x0))) {
      pe__.XER_CA.access().store(Data.coerce(BIT, vars__.temp1.access().load()));
    } else {
      pe__.XER_CA.access().store(Data.valueOf(BIT, 0x0));
    }
    if (Rc_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (ra.access(pe__, vars__).load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.CR0_EQ.access().store(Data.valueOf(BIT, 0x1));
      } else if (ra.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(BIT, 0x1))) {
        pe__.CR0_LT.access().store(Data.valueOf(BIT, 0x1));
      } else {
        pe__.CR0_GT.access().store(Data.valueOf(BIT, 0x1));
      }
      pe__.CR0_SO.access().store(pe__.XER_SO.access().load());
    }
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}