/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code L1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class L1 extends Cache<L1.Entry, PA> {
  private static L1 instance = null;

  public static L1 get() {
    if (null == instance) {
      instance = new L1();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector tag;
    public final BitVector data;

    public Entry() {
      this.tag = BitVector.newEmpty(12);
      this.data = BitVector.newEmpty(16);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.tag.assign(other.tag);
      this.data.assign(other.data);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          tag,
          data
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [tag=0x%s, data=0x%s]",
          tag.toHexString(),
          data.toHexString()
          );
    }
  }
  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return pa.value.field(1, 1);
    }
  };

  private static final Matcher<L1.Entry, PA> MATCHER = new Matcher<L1.Entry, PA>() {
    @Override
    public boolean areMatching(final L1.Entry data, final PA pa) {
      return pa.value.field(13, 2).equals(data.tag);
    }
  };

  private L1() {
    super(
      new BigInteger("2", 10),
      4,
      PolicyId.PLRU,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected PA newAddress() {
    return new PA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }
}
