/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.jl;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderJl} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJl extends DecoderItem {
  private static DecoderJl instance = null;

  public static DecoderJl get() {
    if (null == instance) {
      instance = new DecoderJl();
    }
    return instance;
  }

  private DecoderJl() {
    super(
        16,
        true,
        "0111110000000000",
        "1111111100000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    IsaPrimitive rel = null;

    if (!matchNextOpc(image, BitVector.valueOf("01111100", 2, 8))) {
      return null;
    }
    rel = (IsaPrimitive) readNextPrimitive(image, DecoderREL8.get());
    if (null == rel) {
      return null;
    }

    return newResult(new jl(rel));
  }
}
